/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package systemOperation;

import database.DBBroker;

/**
 *
 * @author student
 */
public abstract class AbstractSystemOperation {

    public void execute(Object object) throws Exception {
        try {
            validate(object);
            checkPrecondition(object);
            executeSystemOperation(object);
            commit();

        } catch (Exception e) {
            rollback();
            throw e;
        }
    }

    protected abstract void validate(Object object);

    protected abstract void checkPrecondition(Object object);

    protected abstract void executeSystemOperation(Object object) throws Exception;

    private void commit() {
        DBBroker.commit();
    }

    private void rollback() {
        DBBroker.rollback();
    }
}
