/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package dbbr;

import domen.Mesto;
import domen.PoslovniPartner;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author student
 */
public class DBBroker {
    
    
    
    Connection konekcija;

    public DBBroker() {
    }
    
     
    public void otvoriKonekciju() throws SQLException{
        
        String url = "jdbc:mysql://localhost:3306/partnerid2";
        konekcija = DriverManager.getConnection(url, "root", "");
        konekcija.setAutoCommit(false);
        System.out.println("USPESNO OSTVARENA KONEKCIJA!!!");
        
    }
    
    public void zatvoriKonekciju() throws SQLException{
        if (konekcija!=null && !konekcija.isClosed()){            
            konekcija.close();
        }
    }
    
    
    public void potvrdiTransakciju() throws SQLException{        
        konekcija.commit();
    }
    
    public void ponistiTransakciju() throws SQLException{
        konekcija.rollback();
    }
    
    
    
    public List<Mesto> vratiSvaMesta() throws SQLException{
        
        List<Mesto> listaMesta = new ArrayList<>();
        
        String upit = "SELECT *"
                + " FROM MESTO";
        System.out.println("upit:"+upit);
        
        Statement naredba = konekcija.createStatement();
        
        ResultSet rs = naredba.executeQuery(upit);
        Mesto m;
        while(rs.next()){
            
            m = new Mesto();
            
            m.setPtt(rs.getLong("ptt"));
            m.setNaziv(rs.getString("naziv"));
            
            listaMesta.add(m);
        }
        
       return listaMesta; 
    }
    
    
    public void sacuvajPartnera(PoslovniPartner partner) throws SQLException{
        
        
        //String upit = "INSERT INTO poslovnipartner VALUES ('"+partner.getMaticniBroj()+"','"+partner.getNaziv()+"','" )";
        
        String upit = "INSERT INTO poslovnipartner VALUES (?,?,?,?,?,?)";
        
        PreparedStatement pnaredba = konekcija.prepareStatement(upit);
        
        pnaredba.setString(1, partner.getMaticniBroj());
        pnaredba.setString(2, partner.getNaziv());
        pnaredba.setString(3, partner.getPib());
        pnaredba.setString(4, partner.getUlica());
        pnaredba.setString(5, partner.getBroj());
        pnaredba.setLong(6, partner.getMesto().getPtt());
        
        pnaredba.executeUpdate();
        
    }
    
    
    public List<PoslovniPartner> vratiSvePartnere() throws SQLException{
        
        List<PoslovniPartner> listaPartnera = new ArrayList<>();
        //I NACIN
        //String upit = "SELECT * from PoslovniPartner pp INNER JOIN Mesto m on pp.mesto=m.ptt";
        
        //  II NACIN
        String upit = "SELECT * from PoslovniPartner pp";
        Statement naredba = konekcija.createStatement();
        
        ResultSet rsPartneri = naredba.executeQuery(upit);
        PoslovniPartner partner;
        
        while(rsPartneri.next()){
            
            partner = new PoslovniPartner();
            
            partner.setMaticniBroj(rsPartneri.getString("maticniBroj"));
            partner.setNaziv(rsPartneri.getString("naziv"));
            partner.setPib(rsPartneri.getString("pib"));
            partner.setUlica(rsPartneri.getString("ulica"));
            partner.setBroj(rsPartneri.getString("broj"));
            
            // II nacin
            partner.setMesto(vratiMesto(rsPartneri.getLong("mesto")));
            
            /*
             I NACIN
            Mesto m = new Mesto();
            m.setPtt(rsPartneri.getLong("ptt"));            
            m.setNaziv(rsPartneri.getString("m.naziv"));
            partner.setMesto(m);
            */
            
            
            
            
            
            
            listaPartnera.add(partner);
        }
        
        
        
        
        return listaPartnera;
        
    }
    
    
    public Mesto vratiMesto(long ptt) throws SQLException{
        
        String upit = "SELECT * FROM MESTO WHERE ptt ="+ptt;
        
        Statement naredba = konekcija.createStatement();
        
        ResultSet rs = naredba.executeQuery(upit);
        Mesto m;
        if (rs.next()){
            
            m = new Mesto();            
            m.setPtt(rs.getLong("ptt"));
            m.setNaziv(rs.getString("naziv"));
            
            return m;
            
        }
        
        return null;
        
    }
    
    
    
    public static void main(String[] args) {
        
        try {
            DBBroker dbbr = new DBBroker();
            dbbr.otvoriKonekciju();
            
        } catch (SQLException ex) {
            Logger.getLogger(DBBroker.class.getName()).log(Level.SEVERE, null, ex);
        }
    }
    
    
}
